/*
   Example program #2 from the CGRAPH documentation.
*/
/*
   Compile this with your compiler, then Link it with the supplied object
   modules.
*/
#include <stdio.h>
#include <chedit.h>     /* Defines of the CHEDIT functions.  Use it if your
                           compiler does strong type checking. */
#include <cgraph.c>     /* The READCSET, WRITECSET, PRINTBANNER, and
                           PRINTCOLUMN routines are C source, included in
                           this file. */
#define CYAN    1
#define MAGENTA 2 
#define WHITE   3       /* color definitions */

unsigned char shapes[1024];   /* character set storage */
int window1[6],window2[6],window3[6];
                              /* the character "strings" to be displayed */
int i,m,n,p,errno,delay,delta;
                              /* loop indices and such */
char ch;                      /* for user response */

unsigned long hold;           /* temporary storage for saving the system
                                 graphics character vector */
unsigned int ofs,seg;         /* the ofset and segment of the saved system
                                 vector */

main()
   {
   errno = readcset(shapes,"slotmchn.chr");
                             /* read the character set */
   if (!errno)               /* if all is ok */
      {
      grmode(4);          /* set 320 x 200 graphics */
                          /* use the routine appropriate to your compiler */
      cursor_pos(20,3);   /* use the routine appropriate to your compiler */
      puts("Press Return to roll again");
                          /* let the user know what to do */
      hold = getvect();   /* save the system vector */
      ofs = (unsigned int) (hold & 0xffff);
      seg = (unsigned int) ((hold >> 16) & 0xffff);
      setvect(shapes);    /* and put in our own */
      for (i = 0; i < 5; i++)  /* set up the bells and whistles (and cherries */
         {                     /* and lemons and...) */
         window1[i] = i;   /* use these characters */
         window2[i] = i+10;
         window3[i] = i+20;
         }
      for (i = 0; i < 5; i++)
         {
         copychar(shapes,window1[i],window2[i]);
                       /* copy the pictures from window1 to window 2 */
         copychar(shapes,window1[i],window3[i]);
                       /* and window 3 */
         }
      do               /* now do the display */
         {
         i = 8*((rand() % 11)+5);
                          /* spin window 1 5 to 15 times (8 rows/char) */
         m = i+8*((rand() % 6)+5);
                          /* window 2 spins a little longer */
         n = m+8*((rand() % 6)+5);
                          /* and window 3 longer yet */
         printcolumn(5,10,window1,1,WHITE);
                          /* display the initial characters */
         printcolumn(5,15,window2,1,WHITE);
         printcolumn(5,20,window3,1,WHITE);
                          /* Note: for displaying 1 character, gratchar */
                          /* could also be used. */
                          /* e.g. gratchar(5,x,windowx[0],WHITE) */
         delay = 0;       /* start off fast */
         do
            {
            if (i)        /* each window rolls its own number of times */
               {
               columndown(shapes,window1,5);  /* roll window */
               i--;       /* count it */
               if (i == 0)
                  delay += 50;
                           /* if this window is not going to roll */
                           /* anymore, make up for the processing */
                           /* time lost not updating it */
               }
            if (m)        /* this looks just like the previous one */
               {
               columndown(shapes,window2,5);
               m--;
               if (m == 0)
                  delay += 50;
               }
            columndown(shapes,window3,5);
            n--;     /* the 3rd window needs no fancy processing, as we
                        know it will be spinning to the very end */
            for (delta = 0; delta < delay; delta++);  /* waste a little time */
            delay += 10;    /* waste a little more time next time */
            printcolumn(5,10,window1,1,WHITE);  /* update the windows */
            printcolumn(5,15,window2,1,WHITE);
            printcolumn(5,20,window3,1,WHITE);
            } while (n);       /* end of inner repeat loop */
         ch = getchar();    /* get the users response */
                            /* anything fancier would be compiler dependent */
         } while (ch == '\n');  /* and repeat until it is not a CR */
      restorevect(ofs,seg);     /* put the system vector back */
      grmode(3);            /* restore the regular screen */
      }                     /* end of the if statement */
   }                        /* end of the program */
